##############################################################################
# Construction de la racine: .
##############################################################################

# procedure to show window .
proc ShowWindow. { args} {
    
    # Window manager configurations
    global font1
    wm geometry . +0+0
    wm positionfrom . program
    wm sizefrom . program
    wm minsize . 10 10
    wm title . {daTac}
    
    # build widget .fe
    frame .fe 
    
    # build widget .fe.e
    entry .fe.e \
	-cursor {top_left_arrow}\
	-font $font1\
	-bg {grey80} \
	-relief {flat}\
	-state {disabled}\
	-textvariable {varFilename}
    
    # build widget .fe.lbl
    label .fe.lbl \
	-relief {flat}\
	-font $font1\
	-bg {grey80} \
	-width {40}\
	-text {Comments about Data File:}
    
    # pack widget .fe
    # pack append .fe \
	# .fe.lbl {left frame e expand fillx} \
	# .fe.e {top frame center expand fillx} 
    pack append .fe \
	.fe.lbl {left frame e}  \
	.fe.e {top frame w expand fillx}
    
    # build widget .ftext
    frame .ftext \
	-relief {raised}
    
    # build widget .ftext.sy
    scrollbar .ftext.sy \
	-command {.ftext.text yview}\
	-relief {raised}
    
    # build widget .ftext.text
    text .ftext.text \
	-font $font1\
	-borderwidth {2}\
	-height {6}\
	-relief {raised}\
	-width {46}\
	-wrap {word}\
	-yscrollcommand {.ftext.sy set}
    
    # pack widget .ftext
    pack append .ftext \
	.ftext.sy {left frame center filly} \
	.ftext.text {top frame center expand fill} 
    
    # build widget .menubar
    frame .menubar \
	-borderwidth {2}\
	-relief {raised}
    
    # build widget .menubar.mbdata
    menubutton .menubar.mbdata \
	-menu {.menubar.mbdata.m}\
	-font $font1\
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-text {Data}\
	-width {14}
    
    # build widget .menubar.mbdata.m
    menu .menubar.mbdata.m -title "daTac: Menu Data" -tearoff "false"
    .menubar.mbdata.m add command\
	-command {
	    ShowWindow.topclauses
	}\
	-font $font1 \
	-label {Clauses}
    .menubar.mbdata.m add separator
    .menubar.mbdata.m add command\
	-command {
	    ShowWindow.topoperators
	    InitTopoperators
	}\
	-font $font1 \
	-label {Operators}
    
    # build widget .menubar.mbexecution
    menubutton .menubar.mbexecution \
	-menu {.menubar.mbexecution.m}\
	-font $font1\
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-text {Execution}\
	-width {14}
    
    # build widget .menubar.mbexecution.m
    menu .menubar.mbexecution.m -title "daTac: Menu Execution" -tearoff "false"
    .menubar.mbexecution.m add radiobutton\
	-font $font1 \
	-label {Ordering Strategy}\
	-value {0}\
	-variable {varOrdStrategy}
    .menubar.mbexecution.m add radiobutton\
	-font $font1 \
	-label {Positive Strategy}\
	-value {1}\
	-variable {varOrdStrategy}
    .menubar.mbexecution.m add separator
    .menubar.mbexecution.m add radiobutton\
	-font $font1 \
	-label {No Constraints}\
	-value {0}\
	-variable {varCntStrategy}
    .menubar.mbexecution.m add radiobutton\
	-font $font1 \
	-label {Basic Strategy}\
	-value {1}\
	-variable {varCntStrategy}
    .menubar.mbexecution.m add radiobutton\
	-font $font1 \
	-label {Constraint Strategy}\
	-value {2}\
	-variable {varCntStrategy} \
	-state {disabled}
    # Comment previous line and delete previous backslash
    # for using full unification constraints.
    .menubar.mbexecution.m add separator
    global varCheckUp flagInterStats
    .menubar.mbexecution.m add command\
	-command {
	    ShowWindow.topcheckup
	    InitTopcheckup
	    focus .topcheckup.f.e
	}\
	-font $font1 \
	-label "No periodical check-up"
    .menubar.mbexecution.m add checkbutton\
	-font $font1 \
	-label {Intermediate Statistics} \
	-variable {flagInterStats} \
	-state disabled
    .menubar.mbexecution.m add separator
    .menubar.mbexecution.m add command\
	-command {
	    # On incremente $countExec
	    global countExec
	    incr countExec
	    
	    # On sauvegarde le nom courant du fichier de donnee dans $fileExec
	    global varFilename ; global varPathname
	    global fileExec
	    if {$varFilename == ""} {
		set fileExec($countExec) {}
	    } else {
		set fileExec($countExec) "$varPathname[file rootname $varFilename]"
	    }
	    
	    # On execute rdatac en mode automatique
	    global selectPatternData
	    global pathTmp
	    global nomFichTmp
	    set fich "$nomFichTmp.$countExec"
	    set fich "$pathTmp$fich"
	    if {[SaveDataToFile "$fich[file extension $selectPatternData]"] == 1} {
		ExecAutoDatac $fich $countExec
	    }
	    catch "unset fich"
	}\
	-font $font1 \
	-label {Run Automatically}
    .menubar.mbexecution.m add command\
	-command {
	    # On incremente $countExec
	    global countExec
	    incr countExec
	    
	    # On sauvegarde le nom courant du fichier de donnee dans $fileExec
	    global varFilename ; global varPathname
	    global fileExec
	    if {$varFilename == ""} {
		set fileExec($countExec) {}
	    } else {
		set fileExec($countExec) "$varPathname[file rootname $varFilename]"
	    }
	    
	    # On execute rdatac en mode manuel
	    global selectPatternData
	    global pathTmp
	    global nomFichTmp
	    set fich "$nomFichTmp.$countExec"
	    set fich "$pathTmp$fich"
	    if {[SaveDataToFile "$fich[file extension $selectPatternData]"] == 1} {
		ExecManDatac $fich $countExec
	    }
	    catch "unset fich"
	}\
	-font $font1 \
	-label {Run Manually}
    
    # build widget .menubar.mbfile
    menubutton .menubar.mbfile \
	-menu {.menubar.mbfile.m}\
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-text {File}\
	-width {14}
    
    # build widget .menubar.mbfile.m
    menu .menubar.mbfile.m -title "daTac: Menu File" -tearoff "false"
    .menubar.mbfile.m add command\
	-command {
	    ReinitData
	    global varFilename ; set varFilename ""
	}\
	-font $font1 \
	-label {Clear}
    .menubar.mbfile.m add command\
	-command {
	    ShowWindow.topeditfile
	    InitTopeditfile
	    focus .topeditfile.fePath.f2.e
	}\
	-font $font1 \
	-label {Edit}
    .menubar.mbfile.m add command\
	-command {
	    ShowWindow.toploadfile
	    InitToploadfile
	    focus .toploadfile.fePath.f2.e
	}\
	-font $font1 \
	-label {Load}
    .menubar.mbfile.m add command\
	-command {
	    ShowWindow.topsavefile
	    InitTopsavefile
	    focus .topsavefile.feFile.f2.e
	}\
	-font $font1 \
	-label {Save}
    .menubar.mbfile.m add separator
    .menubar.mbfile.m add command\
	-command {
	    ExecAutoEnd
	    ExecManEnd
	    exit
	} \
	-font $font1 \
	-label {Quit}
    
    # build widget .menubar.mbhelp
    menubutton .menubar.mbhelp \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-text {Help}\
	-width {14}
    
    # bindings
    bind .menubar.mbhelp <Button-1> {
	global entreeTopic
	set entreeTopic "How to use this Help"
	LoadHelp "How to use this Help.hlp"
    }
    
    # build widget .menubar.mbparameters
    menubutton .menubar.mbparameters \
	-menu {.menubar.mbparameters.m}\
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-text {Parameters}\
	-width {14}
    
    # build widget .menubar.mbparameters.m
    menu .menubar.mbparameters.m -title "daTac: Menu Parameters" -tearoff "false"
    .menubar.mbparameters.m add command\
	-command {
	    ShowWindow.topmaximum varMaxNumberClauses 0 "Maximal Number of Clauses"
	    InitTopmaximum varMaxNumberClauses
	    focus .topmaximum.f.e
	}\
	-font $font1 \
	-label {Maximal Number of Clauses: 1000}
    .menubar.mbparameters.m add command\
	-command {
	    ShowWindow.topmaxornone varSizeClausesLimited 1 "Maximal Size of Clauses"
	    InitTopmaxornone varSizeClausesLimited
	    focus .topmaxornone.f.e
	}\
	-font $font1 \
	-label {No Maximal Size of Clauses}

    .menubar.mbparameters.m add command\
	-command {
	    ShowWindow.topmaxornone varNbVarLimited 2 "Maximal Number of Variables"
	    InitTopmaxornone varNbVarLimited
	    focus .topmaxornone.f.e
	}\
	-font $font1 \
	-label {No Maximal Number of Variables}

    .menubar.mbparameters.m add separator

    .menubar.mbparameters.m add checkbutton\
	-font $font1 \
	-label {Uncomplete AC Unification}\
	-variable {flagUncompleteACUnification}
    .menubar.mbparameters.m add command\
	-command {
	    ShowWindow.topmaxornone varMaxNumberMgu 5 "Maximal Number of MGUs"
	    InitTopmaxornone varMaxNumberMgu
	    focus .topmaxornone.f.e
	}\
	-font $font1 \
	-label {No Maximal Number of MGUs}

    .menubar.mbparameters.m add separator

    .menubar.mbparameters.m add cascade\
	-font $font1 \
	-label {Strategy of Simplification}\
	-menu {.menubar.mbparameters.m.stratsimpl}
    .menubar.mbparameters.m add command\
	-command {
	    ShowWindow.topmaxornone varMaxDepthSimpl 8 "Maximal Depth for Simplification"
	    InitTopmaxornone varMaxDepthSimpl
	    focus .topmaxornone.f.e
	}\
	-font $font1 \
	-label {No Maximal Depth for Simplification}
    .menubar.mbparameters.m add cascade\
	-font $font1 \
	-label {Subsumption}\
	-menu {.menubar.mbparameters.m.subsumption}

    .menubar.mbparameters.m add separator

    .menubar.mbparameters.m add cascade\
	-font $font1 \
	-label {Strategy of Deduction}\
	-menu {.menubar.mbparameters.m.stratded}
    .menubar.mbparameters.m add command\
	-command {
	    ShowWindow.topmaxornone varMaxDepthPara 12 "Maximal Depth for Paramodulation"
	    InitTopmaxornone varMaxDepthPara
	    focus .topmaxornone.f.e
	}\
	-font $font1 \
	-label {No Maximal Depth for Paramodulation}

    .menubar.mbparameters.m add separator

    .menubar.mbparameters.m add cascade\
	-font $font1 \
	-label {Trace Degree}\
	-menu {.menubar.mbparameters.m.tracedegree}
    .menubar.mbparameters.m add cascade\
	-font $font1 \
	-label {Preference for Clauses}\
	-menu {.menubar.mbparameters.m.preference}
    .menubar.mbparameters.m add checkbutton\
	-font $font1 \
	-label {Simplification before Subsumption}\
	-variable {flagSimplifBeforeSubsumption}
    .menubar.mbparameters.m add checkbutton\
	-font $font1 \
	-label {Non-equational Clauses first}\
	-variable {flagNonEquationalClausesFirst}

    .menubar.mbparameters.m add separator

    .menubar.mbparameters.m add command\
	-command {
	    ShowWindow.topcombdedrules
	    InitTopcombdedrules
	}\
	-font $font1 \
	-label {Combination of Deductions}
    
    # build widget .menubar.mbparameters.m.preference
    menu .menubar.mbparameters.m.preference -title "daTac: Menu Preference" -tearoff "false"
    .menubar.mbparameters.m.preference add radiobutton\
	-font $font1 \
	-label {None}\
	-value {0}\
	-variable {varPrefClauses}
    .menubar.mbparameters.m.preference add radiobutton\
	-font $font1 \
	-label {Conjecture}\
	-value {1}\
	-variable {varPrefClauses}
    .menubar.mbparameters.m.preference add radiobutton\
	-font $font1 \
	-label {Theory}\
	-value {2}\
	-variable {varPrefClauses}
    .menubar.mbparameters.m.preference add separator
    .menubar.mbparameters.m.preference add checkbutton\
	-font $font1 \
	-label {Negative Clauses}\
	-command {
	    if { $flagPrefNegClauses } { set flagPrefPosClauses 0 }
	}\
	-variable {flagPrefNegClauses}
    .menubar.mbparameters.m.preference add checkbutton\
	-font $font1 \
	-label {Positive Clauses}\
	-command {
	    if { $flagPrefPosClauses } { set flagPrefNegClauses 0 }
	}\
	-variable {flagPrefPosClauses}
    
    # build widget .menubar.mbparameters.m.stratsimpl
    menu .menubar.mbparameters.m.stratsimpl -title "daTac: Menu Strategy of Simplification" -tearoff "false"
    .menubar.mbparameters.m.stratsimpl add checkbutton\
	-font $font1 \
	-label {Simplification} \
	-variable {flagSimplification} \
	-command {
	    if { $flagSimplification } {
		.menubar.mbparameters.m.stratsimpl entryconfigure 1 -state active
	    } else {
		.menubar.mbparameters.m.stratsimpl entryconfigure 1 -state disabled
	    }
	}
    .menubar.mbparameters.m.stratsimpl add checkbutton\
	-font $font1 \
	-label {Otter-like Simplification}\
	-variable {flagOtterLikeSimpl}
    .menubar.mbparameters.m.stratsimpl add checkbutton\
	-font $font1 \
	-label {Other Simplifications}\
	-variable {flagOtherSimplifications}

    # build widget .menubar.mbparameters.m.stratded
    menu .menubar.mbparameters.m.stratded -title "daTac: Menu Strategy of Deduction" -tearoff "false"
    .menubar.mbparameters.m.stratded add radiobutton \
	-font $font1 \
	-label {Non-Complete} \
	-value {1} \
	-variable {varResearchStrategy}
    .menubar.mbparameters.m.stratded add radiobutton \
	-font $font1 \
	-label {Complete} \
	-value {2} \
	-variable {varResearchStrategy}
    .menubar.mbparameters.m.stratded add radiobutton \
	-font $font1 \
	-label {Breadth First} \
	-value {3} \
	-variable {varResearchStrategy}
    .menubar.mbparameters.m.stratded add radiobutton \
	-font $font1 \
	-label {Otter-like} \
	-value {4} \
	-variable {varResearchStrategy}
    .menubar.mbparameters.m.stratded add separator
    .menubar.mbparameters.m.stratded add radiobutton \
	-font $font1 \
	-label {Paramodulation} \
	-value {0} \
	-variable {flagDeductionStrategy}
    .menubar.mbparameters.m.stratded add radiobutton \
	-font $font1 \
	-label {Superposition} \
	-value {1} \
	-variable {flagDeductionStrategy}
    
    # build widget .menubar.mbparameters.m.subsumption
    menu .menubar.mbparameters.m.subsumption -title "daTac: Menu Subsumption" -tearoff "false"
    .menubar.mbparameters.m.subsumption add radiobutton \
	-font $font1 \
	-label {None} \
	-value {0} \
	-command {
	    set flagUseBackSubs 0
	    .menubar.mbparameters.m.subsumption entryconfigure 4 -state disabled
	} \
	-variable {varSubsumption}
    .menubar.mbparameters.m.subsumption add radiobutton\
	-font $font1 \
	-label {AC Matching}\
	-value {1}\
	-command {
	    .menubar.mbparameters.m.subsumption entryconfigure 4 -state active
	} \
	-variable {varSubsumption}
    .menubar.mbparameters.m.subsumption add radiobutton\
	-font $font1 \
	-label {Gottlob&Leitsch}\
	-value {2}\
	-command {
	    .menubar.mbparameters.m.subsumption entryconfigure 4 -state active
	} \
	-variable {varSubsumption}
    .menubar.mbparameters.m.subsumption add separator
    .menubar.mbparameters.m.subsumption add checkbutton\
	-font $font1 \
	-label {Backward Subsumption} \
	-variable {flagUseBackSubs}
    
    # build widget .menubar.mbparameters.m.tracedegree
    menu .menubar.mbparameters.m.tracedegree -title "daTac: Menu Trace Degree" -tearoff "false"
    .menubar.mbparameters.m.tracedegree add radiobutton\
	-font $font1 \
	-label {Nothing}\
	-value {0}\
	-variable {varTraceDegree}
    .menubar.mbparameters.m.tracedegree add radiobutton\
	-font $font1 \
	-label {Inferences}\
	-value {1}\
	-variable {varTraceDegree}
    .menubar.mbparameters.m.tracedegree add radiobutton\
	-font $font1 \
	-label {Detailed}\
	-value {2}\
	-variable {varTraceDegree}
    .menubar.mbparameters.m.tracedegree add radiobutton\
	-font $font1 \
	-label {All}\
	-value {3}\
	-variable {varTraceDegree}
    
    # pack widget .menubar
    pack append .menubar \
	.menubar.mbfile {left frame center expand fillx} \
	.menubar.mbdata {left frame center expand fillx} \
	.menubar.mbparameters {left frame center expand fillx} \
	.menubar.mbexecution {left frame center expand fillx} \
	.menubar.mbhelp {left frame center expand fillx} 
    
    # pack widget .
    pack append . \
	.menubar {top frame center fillx} \
	.fe {top frame center fillx} \
	.ftext {top frame center expand fill} 
    
    # bindings
    bind . <Enter> {focus .ftext.text}
    bind all <Button-3> {
	selection clear %W
	catch ".topoperators.fl.fbstatus.mb configure -state disabled"
	catch ".topoperators.fl.fbAC_C.mb configure -state disabled"
	catch ".topoperators.fminop.bStore configure -state disabled"
	catch ".topclauses.f4.bErase configure -state disabled"
	catch ".topclauses.f4.bGet configure -state disabled"
	catch ".topclauses.f4.bReplace configure -state disabled"
#	catch ".toppref4infrules.fb.bAdd configure -state disabled"
#	catch ".toppref4infrules.fb.bRemove configure -state disabled"
    }
    
#    if {$tkVersion >= 3.0} {
	tk_menuBar .menubar .menubar.mbdata .menubar.mbexecution .menubar.mbfile .menubar.mbhelp .menubar.mbparameters
#    } {
#	tk_menus . .menubar.mbdata .menubar.mbexecution .menubar.mbfile .menubar.mbhelp .menubar.mbparameters
#    }
    
    if {"[info procs XFEdit]" != ""} {
	catch "XFMiscBindWidgetTree .xfEdit"
	after 2 "catch {XFEditSetShowWindows}"
    }
}
