##############################################################################
# Construction de la fenetre .topsaveexe
##############################################################################

# procedure to show window ShowWindow.topsaveexe
proc ShowWindow.topsaveexe { msg selectPattern saveFunction args } {
    # xf ignore me 7

    # build widget .topsaveexe
    if {"[info procs XFEdit]" != ""} {
	catch "XFDestroy .topsaveexe"
    } {
	catch "destroy .topsaveexe"
    }
    toplevel .topsaveexe 
    
    # Window manager configurations
    wm positionfrom .topsaveexe ""
    wm sizefrom .topsaveexe ""
    wm minsize .topsaveexe 10 10
    wm title .topsaveexe "daTac: Save $msg"

    global {font1}
    
    # bindings
    bind .topsaveexe <Enter> {focus .topsaveexe.feFile.f2.e}
    
    # build widget .topsaveexe.bCancel
    button .topsaveexe.bCancel \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    DestroyWindow .topsaveexe
	    global numSaveExe
	    set numSaveExe 0
	} \
	-cursor {circle} \
	-text {Cancel}
    
    # build widget .topsaveexe.bOk
    button .topsaveexe.bOk \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command "TopSaveexeButOk $selectPattern $saveFunction" \
	-cursor {hand1} \
	-text {Ok}

    # build widget .topsaveexe.feFile
    frame .topsaveexe.feFile \
	-borderwidth {2} \
	-relief {raised}
    
    ScrolledEntry .topsaveexe.feFile {Filename:} entreeExeFile
    
    # bindings
    bind .topsaveexe.feFile.f2.e <Key-Return> {.topsaveexe.bOk flash
	.topsaveexe.bOk invoke}
    bind .topsaveexe.feFile.f2.e <Key-Up> {focus .topsaveexe.fePath.f2.e}
    
    # build widget .topsaveexe.fePath
    frame .topsaveexe.fePath \
	-borderwidth {2} \
	-relief {raised}
    
    ScrolledEntry .topsaveexe.fePath {Pathname:} entreeExePath -width {30}

    # bindings
    bind .topsaveexe.fePath.f2.e <Key-Return> "TopSaveexeReturn $selectPattern"
    bind .topsaveexe.fePath.f2.e <Key-Down> {focus .topsaveexe.feFile.f2.e}
    
    # build widget .topsaveexe.flb
    frame .topsaveexe.flb

    ScrolledListbox2 .topsaveexe.flb

    # bindings
    bind .topsaveexe.flb.list <B1-Motion> {%W selection anchor [%W nearest %y]}
    bind .topsaveexe.flb.list <Button-1> {%W selection anchor [%W nearest %y]}
    bind .topsaveexe.flb.list <ButtonRelease-1> "TopSaveexeBR1 %W %y $selectPattern"
    bind .topsaveexe.flb.list <Double-Button-1> "TopSaveexeDB1 %W %y $selectPattern"
    
    # build widget .topsaveexe.lbl
    label .topsaveexe.lbl \
	-font $font1 \
	-bg {grey80} \
	-relief {raised} \
	-text "Save the $msg"
    
    # pack widget .topsaveexe
    pack append .topsaveexe \
	.topsaveexe.lbl {top frame center fill} \
	.topsaveexe.flb {top frame center expand fill} \
	.topsaveexe.fePath {top frame center fill} \
	.topsaveexe.feFile {top frame center fill} \
	.topsaveexe.bCancel {left frame center expand fill} \
	.topsaveexe.bOk {left frame center expand fill} 
    
    if {"[info procs XFEdit]" != ""} {
	catch "XFMiscBindWidgetTree .topsaveexe"
	after 2 "catch {XFEditSetShowWindows}"
    }
}


proc TopSaveexeButOk { selectPattern saveFunction} {
    global entreeExeFile ; global entreeExePath
    set entreeExeFile [string trim $entreeExeFile]
    set entreeExePath [string trim $entreeExePath]
    if {$entreeExeFile != "" && $entreeExePath != ""} {
	set entreeExeFile [AddExtension $entreeExeFile [file extension $selectPattern]]
	set entreeExePath [AddSlash $entreeExePath]
	# Verifier que le repertoire $entreeExePath existe
	if {[file isdirectory $entreeExePath] == 0} {
	    ShowWindow.topmessage
	    .topmessage.msg configure -text "\n\nBad directory name\n\n\"$entreeExePath\".\n\nFile doesn't exist or isn't a directory.\n\n"
	} elseif {[file writable $entreeExePath] == 0} {
	    # Verifier que le repertoire $entreeExePath est ouvert en ecriture
	    ShowWindow.topmessage
	    .topmessage.msg configure -text "\n\nCan't write file in directory\n\n\"$entreeExePath\".\n\nPermission denied.\n\n"
	} elseif {[file exists $entreeExePath$entreeExeFile] == 1 && [file writable $entreeExePath$entreeExeFile] == 0} {
	    # Verifier que le fichier $entreeExeFile est ouvert en ecriture
	    ShowWindow.topmessage
	    .topmessage.msg configure -text "\n\nCan't save execution in file.\n\n\"$entreeExePath$entreeExeFile\"\n\nis not writable.\n\n"
	} else {
	    # Sauvegarder l'execution dans le fichier $entreeExeFile
	    global numSaveExe
	    # TextToFile .topexec$numSaveExe.ftext.text $entreeExePath$entreeExeFile
	    $saveFunction $numSaveExe $entreeExePath$entreeExeFile
	    DestroyWindow .topsaveexe
	    set numSaveExe 0
	}
    }
}


proc TopSaveexeReturn { selectPattern} {
    global entreeExePath ; global entreeExeFile
    global varExePath
    # set entreeExeFile ""
    set entreeExePath [string trim $entreeExePath]
    if {$entreeExePath == ""} {
	set entreeExePath $varExePath
    } else {
	set entreeExePath [SearchDirectory [AddSlash $entreeExePath]]
	if {$entreeExePath == ""} {
	    set entreeExePath $varExePath
	} else {
	    set varExePath $entreeExePath
	}
    }
    LsToListbox  $entreeExePath $selectPattern .topsaveexe.flb.list
    .topsaveexe.fePath.f2.e xview [expr [string length $entreeExePath]-28]
}


proc TopSaveexeBR1 { wid ord selectPattern} {
    $wid selection anchor [$wid nearest $ord]
    set i [$wid curselection]
    if {$i != ""} {
	global varExePath ; global entreeExePath ; global entreeExeFile
	set entreeExePath $varExePath
	set selection [$wid get $i]
	if {$selection != "../" && [file isfile $entreeExePath$selection] == 1} {
	    set entreeExeFile $selection
	    .topsaveexe.feFile.f2.e xview [expr [string length $entreeExeFile]-28]
	} else {
	    # set entreeExeFile ""
	    .topsaveexe.feFile.f2.e xview 0
	}
	catch "unset selection"
    }
    catch "unset i"
}


proc TopSaveexeDB1 { wid ord selectPattern} {
    $wid selection anchor [$wid nearest $ord]
    set i [$wid curselection]
    if {$i != ""} {
	global varExePath ; global entreeExePath ; global entreeExeFile
	set entreeExePath $varExePath
	set selection [$wid get $i]
	if {$selection == "../"} {
	    # set entreeExeFile ""
	    # set entreeExePath [AddSlash [file dirname [file dirname $entreeExePath]]]
	    set entreeExePath [AddSlash [file dirname $entreeExePath]]
	    set varExePath $entreeExePath
	    LsToListbox $entreeExePath $selectPattern .topsaveexe.flb.list
	    .topsaveexe.fePath.f2.e xview [expr [string length $entreeExePath]-28]
	} else {
	    if {[file isfile $entreeExePath$selection] == 1} {
		set entreeExeFile $selection
		.topsaveexe.bOk flash
		.topsaveexe.bOk invoke
	    } else { # $selection est un repertoire
		# set entreeExeFile ""
		set entreeExePath $entreeExePath$selection
		set varExePath $entreeExePath
		LsToListbox $entreeExePath $selectPattern .topsaveexe.flb.list
		.topsaveexe.fePath.f2.e xview [expr [string length $entreeExePath]-28]
	    }
	}
	catch "unset selection"
	set varExePath $entreeExePath
    }
    catch "unset i"
}
